#!/usr/local/bin/python3
from glib import *         # import copy and deepcopy functions
from stackqueue import *   # import stack and queue stuff

# depth first search count version
# visits all nodes
def dfscount(graph, node) :
    visit = array(len(graph), 0)
    dfscountaux(graph, visit, node, 1)
    return visit

def dfscountaux(graph, visit, node, count) :
    print(node)
    visit[node] = count
    count += 1
    for n in graph[node] :
        if visit[n]==0 : count = dfscountaux(graph, visit, n, count)
    return count


def bfscount(graph, node) :
    visit = array(len(graph), 0)
    print(node)
    visit[node] = 1
    count = 2
    queue = [node]

    while len(queue)>0 :
        node = popRight(queue)
        for n in graph[node] :
            if visit[n]==0 :
                print(n)
                visit[n] = count
                count += 1
                pushLeft(queue, n)
    return visit
        
graph = [{1, 2, 3}, set(), {4, 5}, {7}, {6}, {6, 8}, set(), set(), set()]
# relink(graph)
print(graph)

print("BFS")
print(bfscount(graph, 0))

print("DFS")
print(dfscount(graph, 0))
